/*
 * This file is part of Jelie,
 * (c) 2002 Julien Pilet <julien.pilet@epfl.ch> and
 * Stephane Magnenat <stephane.magnenat@epfl.ch>
 *
 * Jelie is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * Jelie is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

@
@ This is the ramloader
@ It can read and write SDRAM, load something in it
@ and boot it.
@ Julien Pilet & Stephane Magnenat, 2002
@

	.text
	.align	4

@ Disable thumb mode
	.code 32

@ Read a word from jtag
@
@ In :    -
@ Out :   r0
@ Mod :   -

.global readrx
readrx:
	@ read anything into rx to clear RR
	@ mrc p14, 0, r0, c9, c0, 0
.readrxloop:
	@ Read the RR bit of TXRXCTRL into flags
	mrc p14, 0, r15, c14, c0, 0
	@ if RX is not valid, loop
	bpl .readrxloop
	@ if RX is valid, read it
	mrc p14, 0, r0, c9, c0, 0
	mov pc, lr

@ Write a word to jtag
@
@ In :    r0
@ Out :   -
@ Mod :   -

.global writetx
writetx:
	@ poll the TR bit of TXRXCTRL into flags
	mrc p14, 0, r15, c14, c0, 0
	bvs writetx
	@ write data into tx
	mcr p14, 0, r0, c8, c0, 0
	mov pc, lr


