/*
 * This file is part of Jelie,
 * (c) 2002 Julien Pilet <julien.pilet@epfl.ch> and
 * Stephane Magnenat <stephane.magnenat@epfl.ch>
 *
 * Jelie is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * Jelie is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __LEDS_S
#define __LEDS_S

#include "pxa250regs.S"

.macro LED_ON gpio
	@ Enable green LED, modifies R0
	mov r0, #0x40000000
	add r0, r0, #0x00E00000	@ PXA250_GPIO_BASE in r0
	mov r1, #(1 << (\gpio -32))
	str r1, [r0, #GPCR1_OFFSET]	
.endm

.macro LED_OFF gpio
	@ Enable green LED, modifies R0
	mov r0, #0x40000000
	add r0, r0, #0x00E00000	@ PXA250_GPIO_BASE in r0
	mov r1, #(1 << (\gpio - 32))
	str r1, [r0, #GPSR1_OFFSET]	
.endm

.macro LED_GREEN_ON
	LED_ON 47
.endm

.macro LED_GREEN_OFF 
	LED_OFF 47
.endm

.macro LED_RED_ON
	LED_ON 46
.endm

.macro LED_RED_OFF 
	LED_OFF 46
.endm

#endif
